var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isArray, isNull, isUndefined } from 'lodash';
import React, { useEffect, useImperativeHandle, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { useAsync, useEvent, useEventCallback, useForceUpdate, useForkRef, useImmer, useRefExtra, useResize } from '@react-devui/hooks';
import { CloseCircleFilled, SwapRightOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName, getVerticalSidePosition } from '@react-devui/utils';
import dayjs from '../../dayjs';
import { useDValue, useMaxIndex } from '../../hooks';
import { cloneHTMLElement, TTANSITION_DURING_POPUP, WINDOW_SPACE } from '../../utils';
import { ESC_CLOSABLE_DATA } from '../../utils/checkNoExpandedEl';
import { DBaseDesign } from '../_base-design';
import { DBaseInput } from '../_base-input';
import { DComboboxKeyboard } from '../_keyboard';
import { DTransition } from '../_transition';
import { useFormControl } from '../form';
import { useGlobalScroll, useLayout, usePrefixConfig, useTranslation } from '../root';
import { deepCompareDate } from './utils';
function DateInput(props, ref) {
    const { children, dRef, dClassNamePrefix, dFormControl, dModel, dFormat, dVisible, dPlacement, dOrder, dPlaceholder, dSuffix, dRange, dSize, dClearable, dDisabled, dInputRender, onModelChange, onVisibleChange, onUpdatePanel, afterVisibleChange, onClear } = props, restProps = __rest(props, ["children", "dRef", "dClassNamePrefix", "dFormControl", "dModel", "dFormat", "dVisible", "dPlacement", "dOrder", "dPlaceholder", "dSuffix", "dRange", "dSize", "dClearable", "dDisabled", "dInputRender", "onModelChange", "onVisibleChange", "onUpdatePanel", "afterVisibleChange", "onClear"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { dPageScrollRef, dContentResizeRef } = useLayout();
    //#endregion
    //#region Ref
    const boxRef = useRef(null);
    const popupRef = useRef(null);
    const inputLeftRef = useRef(null);
    const inputRightRef = useRef(null);
    const indicatorRef = useRef(null);
    const containerRef = useRefExtra(() => {
        let el = document.getElementById(`${prefix}-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${prefix}-root`;
            document.body.appendChild(el);
        }
        return el;
    }, true);
    const combineInputLeftRef = useForkRef(inputLeftRef, dRef === null || dRef === void 0 ? void 0 : dRef.inputLeft);
    const combineInputRightRef = useForkRef(inputRightRef, dRef === null || dRef === void 0 ? void 0 : dRef.inputRight);
    //#endregion
    const dataRef = useRef({
        focusAnother: false,
        inputValue: ['', ''],
        rangeDate: [null, null],
    });
    const prefix = `${dPrefix}${dClassNamePrefix}`;
    const async = useAsync();
    const [t] = useTranslation();
    const forceUpdate = useForceUpdate();
    const formControlInject = useFormControl(dFormControl);
    const [_value, _changeValue] = useDValue(null, dModel, onModelChange, (a, b) => deepCompareDate(a, b, dFormat), formControlInject);
    let [valueLeft, valueRight = null] = (isArray(_value) ? _value : [_value, null]);
    if (dRange) {
        if (isNull(_value)) {
            [valueLeft, valueRight] = dataRef.current.rangeDate;
        }
        else {
            dataRef.current.rangeDate = [null, null];
        }
    }
    const [isFocus, setIsFocus] = useImmer([false, false]);
    const handleFocusChange = (focus, isLeft) => {
        var _a, _b;
        (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
        if (focus) {
            setIsFocus((draft) => {
                draft.fill(false);
                draft[isLeft ? 0 : 1] = true;
            });
        }
        else {
            dataRef.current.clearTid = async.setTimeout(() => {
                onVisibleChange(false);
                setIsFocus([false, false]);
            }, 20);
        }
    };
    if (!isFocus[0]) {
        dataRef.current.inputValue[0] = isNull(valueLeft) ? '' : dayjs(valueLeft).format(dFormat);
    }
    if (!isFocus[1]) {
        dataRef.current.inputValue[1] = isNull(valueRight) ? '' : dayjs(valueRight).format(dFormat);
    }
    const hasFocus = isFocus.some((f) => f);
    const changeValue = (date) => {
        const index = isFocus[0] ? 0 : 1;
        dataRef.current.inputValue[index] = dayjs(date).format(dFormat);
        if (dRange) {
            if (isNull(_value)) {
                dataRef.current.rangeDate[index] = date;
                if (dataRef.current.rangeDate.every((v) => !isNull(v))) {
                    dataRef.current.focusAnother = dOrder(dataRef.current.rangeDate);
                    if (dataRef.current.focusAnother) {
                        dataRef.current.rangeDate.reverse();
                        dataRef.current.inputValue.reverse();
                    }
                    _changeValue(dataRef.current.rangeDate);
                }
            }
            else {
                _changeValue((draft) => {
                    draft[index] = date;
                    dataRef.current.focusAnother = dOrder(draft);
                    if (dataRef.current.focusAnother) {
                        draft.reverse();
                        dataRef.current.inputValue.reverse();
                    }
                });
            }
        }
        else {
            _changeValue(date);
        }
        forceUpdate();
    };
    const clearable = dClearable && !isNull(_value) && !dVisible && !dDisabled;
    const maxZIndex = useMaxIndex(dVisible);
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: '-200vh',
        left: '-200vw',
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const updatePosition = useEventCallback(() => {
        if (dVisible && boxRef.current && popupRef.current) {
            const height = popupRef.current.offsetHeight;
            const maxWidth = window.innerWidth - WINDOW_SPACE * 2;
            const width = Math.min(popupRef.current.scrollWidth, maxWidth);
            const { top, left, transformOrigin } = getVerticalSidePosition(boxRef.current, { width, height }, {
                placement: dPlacement,
                inWindow: WINDOW_SPACE,
            });
            setPopupPositionStyle({
                top,
                left,
                maxWidth,
            });
            setTransformOrigin(transformOrigin);
        }
    });
    const globalScroll = useGlobalScroll(updatePosition, !dVisible);
    useEvent(dPageScrollRef, 'scroll', updatePosition, { passive: true }, !dVisible || globalScroll);
    useResize(boxRef, updatePosition, !dVisible);
    useResize(popupRef, updatePosition, !dVisible);
    useResize(dContentResizeRef, updatePosition, !dVisible);
    useEffect(() => {
        if (boxRef.current && indicatorRef.current) {
            let focus = false;
            const boxRect = boxRef.current.getBoundingClientRect();
            if (inputLeftRef.current && document.activeElement === inputLeftRef.current) {
                const rect = inputLeftRef.current.getBoundingClientRect();
                indicatorRef.current.style.cssText = `left:${rect.left - boxRect.left}px;width:${rect.width}px;opacity:1;`;
                focus = true;
            }
            if (inputRightRef.current && document.activeElement === inputRightRef.current) {
                const rect = inputRightRef.current.getBoundingClientRect();
                indicatorRef.current.style.cssText = `left:${rect.left - boxRect.left}px;width:${rect.width}px;opacity:1;`;
                focus = true;
            }
            if (!focus) {
                indicatorRef.current.style.cssText += 'opacity:0;';
            }
        }
    });
    useEffect(() => {
        if (dataRef.current.focusAnother && document.activeElement) {
            const el = document.activeElement.parentElement;
            for (let index = 0; index < el.childElementCount; index++) {
                const element = el.children.item(index);
                if (element.tagName.toLowerCase() === 'input' && element !== document.activeElement) {
                    element.focus({ preventScroll: true });
                    break;
                }
            }
        }
        dataRef.current.focusAnother = false;
    });
    const preventBlur = (e) => {
        if (e.target !== inputLeftRef.current && e.target !== inputRightRef.current && e.button === 0) {
            e.preventDefault();
        }
    };
    useImperativeHandle(ref, () => ({
        updatePosition,
    }), [updatePosition]);
    const getInputNode = (isLeft) => (_jsx(DComboboxKeyboard, Object.assign({ dVisible: dVisible, dEditable: true, dHasSub: false, onVisibleChange: onVisibleChange, onFocusChange: () => {
            // Only for popup open/close
        } }, { children: ({ render: renderComboboxKeyboard }) => (_jsx(DBaseInput, Object.assign({ dFormControl: dFormControl, dLabelFor: isLeft }, { children: ({ render: renderBaseInput }) => {
                const index = isLeft ? 0 : 1;
                const value = isLeft ? valueLeft : valueRight;
                const inputRender = (dInputRender !== null && dInputRender !== void 0 ? dInputRender : [])[index];
                const input = renderComboboxKeyboard(renderBaseInput(_jsx("input", { ref: isLeft ? combineInputLeftRef : combineInputRightRef, className: `${prefix}__input`, type: "text", autoComplete: "off", value: dataRef.current.inputValue[index], placeholder: dPlaceholder[index], disabled: dDisabled, onChange: (e) => {
                        const val = e.currentTarget.value;
                        dataRef.current.inputValue[index] = val;
                        if (dayjs(val, dFormat, true).isValid()) {
                            const date = dayjs(val, dFormat).toDate();
                            onUpdatePanel === null || onUpdatePanel === void 0 ? void 0 : onUpdatePanel(date);
                            changeValue(date);
                        }
                        forceUpdate();
                    }, onKeyDown: (e) => {
                        if (e.code === 'Enter') {
                            if (dayjs(dataRef.current.inputValue[index], dFormat, true).isValid()) {
                                if (dRange) {
                                    if (isNull(isLeft ? valueRight : valueLeft)) {
                                        dataRef.current.focusAnother = true;
                                    }
                                    else {
                                        onVisibleChange(false);
                                    }
                                }
                                else {
                                    onVisibleChange(false);
                                }
                            }
                            else {
                                dataRef.current.inputValue[index] = isNull(value) ? '' : dayjs(value).format(dFormat);
                            }
                            forceUpdate();
                        }
                    }, onFocus: () => {
                        if (value && isFocus[isLeft ? 1 : 0]) {
                            onUpdatePanel === null || onUpdatePanel === void 0 ? void 0 : onUpdatePanel(value);
                        }
                        handleFocusChange(true, isLeft);
                    }, onBlur: () => {
                        handleFocusChange(false, isLeft);
                    } })));
                return isUndefined(inputRender) ? input : inputRender(input);
            } }))) })));
    return (_jsxs(_Fragment, { children: [_jsx(DBaseDesign, Object.assign({ dComposeDesign: {
                    active: hasFocus,
                    disabled: dDisabled,
                }, dFormDesign: {
                    control: dFormControl,
                } }, { children: ({ render: renderBaseDesign }) => renderBaseDesign(_jsxs("div", Object.assign({}, restProps, { [ESC_CLOSABLE_DATA]: dVisible }, { ref: boxRef, className: getClassName(restProps.className, prefix, {
                        [`${prefix}--${dSize}`]: dSize,
                        'is-disabled': dDisabled,
                        'is-focus': hasFocus,
                    }), onMouseDown: (e) => {
                        var _a;
                        (_a = restProps.onMouseDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        preventBlur(e);
                    }, onMouseUp: (e) => {
                        var _a;
                        (_a = restProps.onMouseUp) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        preventBlur(e);
                    }, onClick: (e) => {
                        var _a, _b;
                        (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        onVisibleChange(true);
                        if (!hasFocus) {
                            (_b = inputLeftRef.current) === null || _b === void 0 ? void 0 : _b.focus({ preventScroll: true });
                        }
                    } }, { children: [getInputNode(true), dRange && (_jsxs(_Fragment, { children: [_jsx("div", { ref: indicatorRef, className: `${prefix}__indicator` }), _jsx(SwapRightOutlined, { className: `${prefix}__separator` }), getInputNode(false)] })), clearable && (_jsx("div", Object.assign({ className: `${prefix}__clear`, role: "button", "aria-label": t('Clear'), onClick: (e) => {
                                e.stopPropagation();
                                dataRef.current.inputValue = ['', ''];
                                _changeValue(null);
                                onClear === null || onClear === void 0 ? void 0 : onClear();
                            } }, { children: _jsx(CloseCircleFilled, {}) }))), checkNodeExist(dSuffix) && (_jsx("div", Object.assign({ className: `${prefix}__icon`, style: { opacity: clearable ? 0 : 1 } }, { children: dSuffix })))] }))) })), containerRef.current &&
                ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: dVisible, dDuring: TTANSITION_DURING_POPUP, onEnter: updatePosition, afterEnter: () => {
                        afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
                    }, afterLeave: () => {
                        afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
                    } }, { children: (state) => {
                        let transitionStyle = {};
                        switch (state) {
                            case 'enter':
                                transitionStyle = { transform: 'scaleY(0.7)', opacity: 0 };
                                break;
                            case 'entering':
                                transitionStyle = {
                                    transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                                    transformOrigin,
                                };
                                break;
                            case 'leaving':
                                transitionStyle = {
                                    transform: 'scaleY(0.7)',
                                    opacity: 0,
                                    transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                                    transformOrigin,
                                };
                                break;
                            case 'leaved':
                                transitionStyle = { display: 'none' };
                                break;
                            default:
                                break;
                        }
                        return children({
                            date: dRange ? (isNull(_value) ? dataRef.current.rangeDate : _value) : [valueLeft, null],
                            isFocus,
                            changeDate: (date) => {
                                if (isArray(date)) {
                                    dataRef.current.inputValue = date.map((d) => dayjs(d).format(dFormat));
                                    _changeValue(date);
                                }
                                else {
                                    changeValue(date);
                                }
                            },
                            renderPopup: (el) => cloneHTMLElement(el, {
                                ref: popupRef,
                                style: Object.assign(Object.assign(Object.assign(Object.assign({}, el.props.style), popupPositionStyle), { zIndex: maxZIndex }), transitionStyle),
                                onMouseDown: (e) => {
                                    var _a, _b;
                                    (_b = (_a = el.props).onMouseDown) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    preventBlur(e);
                                },
                                onMouseUp: (e) => {
                                    var _a, _b;
                                    (_b = (_a = el.props).onMouseUp) === null || _b === void 0 ? void 0 : _b.call(_a, e);
                                    preventBlur(e);
                                },
                            }),
                        });
                    } })), containerRef.current)] }));
}
export const DDateInput = React.forwardRef(DateInput);
