var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isString } from 'lodash';
import React, { useRef, useState } from 'react';
import { useEvent, useIsomorphicLayoutEffect, useRefExtra, useResize } from '@react-devui/hooks';
import { VerticalAlignTopOutlined } from '@react-devui/icons';
import { checkNodeExist, scrollTo, toPx } from '@react-devui/utils';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DTransition } from '../_transition';
import { useComponentConfig, useGlobalScroll, useLayout } from '../root';
import { DFabButton } from './FabButton';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DFab.Backtop' });
function FabBacktop(props, ref) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dPage, dDistance = 400, dScrollBehavior = 'instant' } = _a, restProps = __rest(_a, ["children", "dPage", "dDistance", "dScrollBehavior"]);
    //#region Context
    const { dPageScrollRef, dContentResizeRef } = useLayout();
    //#endregion
    //#region Ref
    const pageRef = useRefExtra(dPage !== null && dPage !== void 0 ? dPage : (() => dPageScrollRef.current));
    //#endregion
    const dataRef = useRef({});
    const [visible, setVisible] = useState(false);
    const transitionStyles = {
        enter: { opacity: 0 },
        entering: {
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaving: {
            opacity: 0,
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaved: { display: 'none' },
    };
    const updateBackTop = () => {
        if (pageRef.current) {
            const distance = isString(dDistance) ? toPx(dDistance, true) : dDistance;
            setVisible(Math.ceil(pageRef.current.scrollTop) >= distance);
        }
    };
    useIsomorphicLayoutEffect(() => {
        updateBackTop();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    const globalScroll = useGlobalScroll(updateBackTop);
    useEvent(pageRef, 'scroll', updateBackTop, { passive: true }, globalScroll);
    useResize(dContentResizeRef, updateBackTop);
    return (_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE }, { children: (state) => (_jsx(DFabButton, Object.assign({}, restProps, { ref: ref, style: Object.assign(Object.assign({}, restProps.style), transitionStyles[state]), onClick: (e) => {
                var _a, _b, _c;
                (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                if (pageRef.current) {
                    (_c = (_b = dataRef.current).clearTid) === null || _c === void 0 ? void 0 : _c.call(_b);
                    dataRef.current.clearTid = scrollTo(pageRef.current, {
                        top: 0,
                        behavior: dScrollBehavior,
                    });
                }
            } }, { children: checkNodeExist(children) ? children : _jsx(VerticalAlignTopOutlined, {}) }))) })));
}
export const DFabBacktop = React.forwardRef(FabBacktop);
